/*
 * Wazuh app - Mitre sample alerts
 * Copyright (C) 2015-2020 Wazuh, Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Find more information about this on the LICENSE file.
 */

// Mitre
export const rule = [{
    "tactic": "Command and Control",
    "rule": [
      {id: "T1001", technique: "Data Obfuscation" },
      {id: "T1008", technique: "Fallback Channels" },
      {id: "T1024", technique: "Custom Cryptographic Protocol" },
      {id: "T1026", technique: "Multiband Communication" },
      {id: "T1032", technique: "Standard Cryptographic Protocol" },
      {id: "T1043", technique: "Commonly Used Port" },
      {id: "T1065", technique: "Uncommonly Used Port" },
      {id: "T1071", technique: "Standard Application Layer Protocol" },
      {id: "T1079", technique: "Multilayer Encryption" },
      {id: "T1090", technique: "Connection Proxy" },
      {id: "T1092", technique: "Communication Through Removable Media" },
      {id: "T1094", technique: "Custom Command and Control Protocol" },
      {id: "T1095", technique: "Standard Non-Application Layer Protocol" },
      {id: "T1102", technique: "Web Service" },
      {id: "T1104", technique: "Multi-Stage Channels" },
      {id: "T1105", technique: "Remote File Copy" },
      {id: "T1132", technique: "Data Encoding" },
      {id: "T1172", technique: "Domain Fronting" },
      {id: "T1188", technique: "Multi-hop Proxy" },
      {id: "T1205", technique: "Port Knocking" },
      {id: "T1219", technique: "Remote Access Tools" },
      {id: "T1483", technique: "Domain Generation Algorithms" },
    ]
  },
  {
    "tactic": "Exfiltration",
    "rule": [
      {id: "T1002", technique: "Data Compressed" },
      {id: "T1011", technique: "Exfiltration Over Other Network Medium" },
      {id: "T1020", technique: "Automated Exfiltration" },
      {id: "T1022", technique: "Data Encrypted" },
      {id: "T1029", technique: "Scheduled Transfer" },
      {id: "T1030", technique: "Data Transfer Size Limits" },
      {id: "T1041", technique: "Exfiltration Over Command and Control Channel" },
      {id: "T1048", technique: "Exfiltration Over Alternative Protocol" },
      {id: "T1052", technique: "Exfiltration Over Physical Medium" },
      {id: "T1537", technique: "Transfer Data to Cloud Account" },
    ]
  },
  {
    "tactic": "Credential Access",
    "rule": [
      {id: "T1003", technique: "Credential Dumping" },
      {id: "T1040", technique: "Network Sniffing" },
      {id: "T1056", technique: "Input Capture" },
      {id: "T1081", technique: "Credentials in Files" },
      {id: "T1098", technique: "Account Manipulation" },
      {id: "T1110", technique: "Brute Force" },
      {id: "T1111", technique: "Two-Factor Authentication Interception" },
      {id: "T1139", technique: "Bash History" },
      {id: "T1141", technique: "Input Prompt" },
      {id: "T1142", technique: "Keychain" },
      {id: "T1145", technique: "Private Keys" },
      {id: "T1167", technique: "Securityd Memory" },
      {id: "T1171", technique: "LLMNR/NBT-NS Poisoning and Relay" },
      {id: "T1174", technique: "Password Filter DLL" },
      {id: "T1179", technique: "Hooking" },
      {id: "T1187", technique: "Forced Authentication" },
      {id: "T1208", technique: "Kerberoasting" },
      {id: "T1212", technique: "xploitation for Credential Access" },
      {id: "T1214", technique: "Credentials in Registry" },
      {id: "T1503", technique: "Credentials from Web Browsers" },
      {id: "T1522", technique: "Cloud Instance Metadata API" },
      {id: "T1528", technique: "Steal Application Access Token" },
      {id: "T1539", technique: "Steal Web Session Cookie" },
    ]
  },
  {
    "tactic": "Persistence",
    "rule": [
      {id: "T1004", technique: "Winlogon Helper DLL" },
      {id: "T1013", technique: "Port Monitors" },
      {id: "T1015", technique: "Accessibility Features" },
      {id: "T1019", technique: "System Firmware" },
      {id: "T1023", technique: "Shortcut Modification" },
      {id: "T1031", technique: "Modify Existing Service" },
      {id: "T1034", technique: "Path Interception" },
      {id: "T1037", technique: "Logon Scripts" },
      {id: "T1038", technique: "DLL Search Order Hijacking" },
      {id: "T1042", technique: "Change Default File Association" },
      {id: "T1044", technique: "File System Permissions Weakness" },
      {id: "T1050", technique: "New Service" },
      {id: "T1053", technique: "Scheduled Task" },
      {id: "T1058", technique: "Service Registry Permissions Weakness" },
      {id: "T1060", technique: "Registry Run Keys / Startup Folder" },
      {id: "T1062", technique: "Hypervisor" },
      {id: "T1067", technique: "Bootkit" },
      {id: "T1078", technique: "Valid Accounts" },
      {id: "T1084", technique: "Windows Management Instrumentation Event Subscription" },
      {id: "T1098", technique: "Account Manipulation" },
      {id: "T1100", technique: "Web Shell" },
      {id: "T1101", technique: "Security Support Provider" },
      {id: "T1103", technique: "AppInit DLLs" },
      {id: "T1108", technique: "Redundant Access" },
      {id: "T1109", technique: "Component Firmware" },
      {id: "T1122", technique: "Component Object Model Hijacking" },
      {id: "T1128", technique: "Netsh Helper DLL" },
      {id: "T1131", technique: "Authentication Package" },
      {id: "T1133", technique: "External Remote Services" },
      {id: "T1136", technique: "Create Account" },
      {id: "T1137", technique: "Office Application Startup" },
      {id: "T1138", technique: "Application Shimming" },
      {id: "T1150", technique: "Plist Modification" },
      {id: "T1152", technique: "Launchctl" },
      {id: "T1154", technique: "Trap" },
      {id: "T1156", technique: "bash_profile and .bashrc" },
      {id: "T1157", technique: "Dylib Hijacking" },
      {id: "T1158", technique: "Hidden Files and Directories" },
      {id: "T1159", technique: "Launch Agent" },
      {id: "T1160", technique: "Launch Daemon" },
      {id: "T1161", technique: "LC_LOAD_DYLIB Addition" },
      {id: "T1162", technique: "Login Item" },
      {id: "T1163", technique: "Rc.common" },
      {id: "T1164", technique: "Re-opened Applications" },
      {id: "T1165", technique: "Startup Items" },
      {id: "T1166", technique: "Setuid and Setgid" },
      {id: "T1168", technique: "Local Job Scheduling" },
      {id: "T1176", technique: "Browser Extensions" },
      {id: "T1177", technique: "LSASS Driver" },
      {id: "T1179", technique: "Hooking" },
      {id: "T1180", technique: "Screensaver" },
      {id: "T1182", technique: "AppCert DLLs" },
      {id: "T1183", technique: "Image File Execution Options Injection" },
      {id: "T1197", technique: "BITS Jobs" },
      {id: "T1198", technique: "SIP and Trust Provider Hijacking" },
      {id: "T1205", technique: "Port Knocking" },
      {id: "T1209", technique: "Time Providers" },
      {id: "T1215", technique: "Kernel Modules and Extensions" },
      {id: "T1501", technique: "Systemd Service" },
      {id: "T1504", technique: "PowerShell Profile" },
      {id: "T1505", technique: "Server Software Component" },
      {id: "T1519", technique: "Emond" },
      {id: "T1525", technique: "Implant Container Image" },
    ]
  },
  {
    "tactic": "Collection",
    "rule": [
      {id: "T1005", technique: "Data from Local System" },
      {id: "T1025", technique: "Data from Removable Media" },
      {id: "T1039", technique: "Data from Network Shared Drive" },
      {id: "T1056", technique: "Input Capture" },
      {id: "T1074", technique: "Data Staged" },
      {id: "T1113", technique: "Screen Capture" },
      {id: "T1114", technique: "Email Collection" },
      {id: "T1115", technique: "Clipboard Data" },
      {id: "T1119", technique: "Automated Collection" },
      {id: "T1123", technique: "Audio Capture" },
      {id: "T1125", technique: "Video Capture" },
      {id: "T1185", technique: "Man in the Browser" },
      {id: "T1213", technique: "Data from Information Repositories" },
      {id: "T1530", technique: "Data from Cloud Storage Object" },
    ]
  },
  {
    "tactic": "Defense Evasion",
    "rule": [
      {id: "T1006", technique: "File System Logical Offsets" },
      {id: "T1009", technique: "Binary Padding" },
      {id: "T1014", technique: "Rootkit" },
      {id: "T1027", technique: "Obfuscated Files or Information" },
      {id: "T1036", technique: "Masquerading" },
      {id: "T1038", technique: "DLL Search Order Hijacking" },
      {id: "T1045", technique: "Software Packing" },
      {id: "T1054", technique: "Indicator Blocking" },
      {id: "T1055", technique: "Process Injection" },
      {id: "T1064", technique: "Scripting" },
      {id: "T1066", technique: "Indicator Removal from Tools" },
      {id: "T1070", technique: "Indicator Removal on Host" },
      {id: "T1073", technique: "DLL Side-Loading" },
      {id: "T1078", technique: "Valid Accounts" },
      {id: "T1085", technique: "Rundll32" },
      {id: "T1088", technique: "Bypass User Account Control" },
      {id: "T1089", technique: "Disabling Security Tools" },
      {id: "T1090", technique: "Connection Proxy" },
      {id: "T1093", technique: "Process Hollowing" },
      {id: "T1096", technique: "NTFS File Attributes" },
      {id: "T1099", technique: "Timestomp" },
      {id: "T1102", technique: "Web Service" },
      {id: "T1107", technique: "File Deletion" },
      {id: "T1108", technique: "Redundant Access" },
      {id: "T1109", technique: "Component Firmware" },
      {id: "T1112", technique: "Modify Registry" },
      {id: "T1116", technique: "Code Signing" },
      {id: "T1117", technique: "Regsvr32" },
      {id: "T1118", technique: "InstallUtil" },
      {id: "T1121", technique: "Regsvcs/Regasm" },
      {id: "T1122", technique: "Component Object Model Hijacking" },
      {id: "T1126", technique: "Network Share Connection Removal" },
      {id: "T1127", technique: "Trusted Developer Utilities" },
      {id: "T1130", technique: "Install Root Certificate" },
      {id: "T1134", technique: "Access Token Manipulation" },
      {id: "T1140", technique: "Deobfuscate/Decode Files or Information" },
      {id: "T1143", technique: "Hidden Window" },
      {id: "T1144", technique: "Gatekeeper Bypass" },
      {id: "T1146", technique: "Clear Command History" },
      {id: "T1147", technique: "Hidden Users" },
      {id: "T1148", technique: "HISTCONTROL" },
      {id: "T1149", technique: "LC_MAIN Hijacking" },
      {id: "T1150", technique: "Plist Modification" },
      {id: "T1151", technique: "Space after Filename" },
      {id: "T1152", technique: "Launchctl" },
      {id: "T1158", technique: "Hidden Files and Directories" },
      {id: "T1170", technique: "Mshta" },
      {id: "T1181", technique: "Extra Window Memory Injection" },
      {id: "T1183", technique: "Image File Execution Options Injection" },
      {id: "T1186", technique: "Process Doppelgänging" },
      {id: "T1191", technique: "CMSTP" },
      {id: "T1196", technique: "Control Panel Items" },
      {id: "T1197", technique: "BITS Jobs" },
      {id: "T1198", technique: "SIP and Trust Provider Hijacking" },
      {id: "T1202", technique: "Indirect Command Execution" },
      {id: "T1205", technique: "Port Knocking" },
      {id: "T1207", technique: "DCShadow" },
      {id: "T1211", technique: "Exploitation for Defense Evasion" },
      {id: "T1216", technique: "Signed Script Proxy Execution" },
      {id: "T1218", technique: "Signed Binary Proxy Execution" },
      {id: "T1220", technique: "XSL Script Processing" },
      {id: "T1221", technique: "Template Injection" },
      {id: "T1222", technique: "File and Directory Permissions Modification" },
      {id: "T1223", technique: "Compiled HTML File" },
      {id: "T1480", technique: "Execution Guardrails" },
      {id: "T1484", technique: "Group Policy Modification" },
      {id: "T1497", technique: "Virtualization/Sandbox Evasion" },
      {id: "T1500", technique: "Compile After Delivery" },
      {id: "T1502", technique: "Parent PID Spoofing" },
      {id: "T1506", technique: "Web Session Cookie" },
      {id: "T1527", technique: "Application Access Token" },
      {id: "T1535", technique: "Unused/Unsupported Cloud Regions" },
      {id: "T1536", technique: "Revert Cloud Instance" },
    ]
  },
  {
    "tactic": "Discovery",
    "rule": [
      {id: "T1007", technique: "System Service Discovery" },
      {id: "T1010", technique: "Application Window Discovery" },
      {id: "T1012", technique: "Query Registry" },
      {id: "T1016", technique: "System Network Configuration Discovery" },
      {id: "T1018", technique: "Remote System Discovery" },
      {id: "T1033", technique: "System Owner/User Discovery" },
      {id: "T1040", technique: "Network Sniffing" },
      {id: "T1046", technique: "Network Service Scanning" },
      {id: "T1049", technique: "System Network Connections Discovery" },
      {id: "T1057", technique: "Process Discovery" },
      {id: "T1063", technique: "Security Software Discovery" },
      {id: "T1069", technique: "Permission Groups Discovery" },
      {id: "T1082", technique: "System Information Discovery" },
      {id: "T1083", technique: "File and Directory Discovery" },
      {id: "T1087", technique: "Account Discovery" },
      {id: "T1120", technique: "Peripheral Device Discovery" },
      {id: "T1124", technique: "System Time Discovery" },
      {id: "T1135", technique: "Network Share Discovery" },
      {id: "T1201", technique: "Password Policy Discovery" },
      {id: "T1217", technique: "Browser Bookmark Discovery" },
      {id: "T1482", technique: "Domain Trust Discovery" },
      {id: "T1497", technique: "Virtualization/Sandbox Evasion" },
      {id: "T1518", technique: "Software Discovery" },
      {id: "T1526", technique: "Cloud Service Discovery" },
      {id: "T1538", technique: "Cloud Service Dashboard" },
    ]
  },
  {
    "tactic": "Privilege Escalation",
    "rule": [
      {id: "T1013", technique: "Port Monitors" },
      {id: "T1015", technique: "Accessibility Features" },
      {id: "T1034", technique: "Path Interception" },
      {id: "T1038", technique: "DLL Search Order Hijacking" },
      {id: "T1044", technique: "File System Permissions Weakness" },
      {id: "T1050", technique: "New Service" },
      {id: "T1053", technique: "Scheduled Task" },
      {id: "T1055", technique: "Process Injection" },
      {id: "T1058", technique: "Service Registry Permissions Weakness" },
      {id: "T1068", technique: "Exploitation for Privilege Escalation" },
      {id: "T1078", technique: "Valid Accounts" },
      {id: "T1088", technique: "Bypass User Account Control" },
      {id: "T1100", technique: "Web Shell" },
      {id: "T1103", technique: "AppInit DLLs" },
      {id: "T1134", technique: "Access Token Manipulation" },
      {id: "T1138", technique: "Application Shimming" },
      {id: "T1150", technique: "Plist Modification" },
      {id: "T1157", technique: "Dylib Hijacking" },
      {id: "T1160", technique: "Launch Daemon" },
      {id: "T1165", technique: "Startup Items" },
      {id: "T1166", technique: "Setuid and Setgid" },
      {id: "T1169", technique: "Sudo" },
      {id: "T1178", technique: "SID-History Injection" },
      {id: "T1179", technique: "Hooking" },
      {id: "T1181", technique: "Extra Window Memory Injection" },
      {id: "T1182", technique: "AppCert DLLs" },
      {id: "T1183", technique: "Image File Execution Options Injection" },
      {id: "T1206", technique: "Sudo Caching" },
      {id: "T1502", technique: "Parent PID Spoofing" },
      {id: "T1504", technique: "PowerShell Profile" },
      {id: "T1514", technique: "Elevated Execution with Prompt" },
      {id: "T1519", technique: "Emond" },
    ]
  },
  {
    "tactic": "Lateral Movement",
    "rule": [
      {id: "T1017", technique: "Application Deployment Software" },
      {id: "T1021", technique: "Remote Services" },
      {id: "T1028", technique: "Windows Remote Management" },
      {id: "T1037", technique: "Logon Scripts" },
      {id: "T1051", technique: "Shared Webroot" },
      {id: "T1072", technique: "Third-party Software" },
      {id: "T1075", technique: "Pass the Hash" },
      {id: "T1076", technique: "Remote Desktop Protocol" },
      {id: "T1077", technique: "Windows Admin Shares" },
      {id: "T1080", technique: "Taint Shared Content" },
      {id: "T1091", technique: "Replication Through Removable Media" },
      {id: "T1097", technique: "Pass the Ticket" },
      {id: "T1105", technique: "Remote File Copy" },
      {id: "T1155", technique: "AppleScript" },
      {id: "T1175", technique: "Component Object Model and Distributed COM" },
      {id: "T1184", technique: "SSH Hijacking" },
      {id: "T1210", technique: "Exploitation of Remote Services" },
      {id: "T1506", technique: "Web Session Cookie" },
      {id: "T1527", technique: "Application Access Token" },
      {id: "T1534", technique: "Internal Spearphishing" },
    ]
  },
  {
    "tactic": "Execution",
    "rule": [
      {id: "T1028", technique: "Windows Remote Management" },
      {id: "T1035", technique: "Service Execution" },
      {id: "T1047", technique: "Windows Management Instrumentation" },
      {id: "T1053", technique: "Scheduled Task" },
      {id: "T1059", technique: "Command-Line Interface" },
      {id: "T1061", technique: "Graphical User Interface" },
      {id: "T1064", technique: "Scripting" },
      {id: "T1072", technique: "Third-party Software" },
      {id: "T1085", technique: "Rundll32" },
      {id: "T1086", technique: "PowerShell" },
      {id: "T1106", technique: "Execution through API" },
      {id: "T1117", technique: "Regsvr32" },
      {id: "T1118", technique: "InstallUtil" },
      {id: "T1121", technique: "Regsvcs/Regasm" },
      {id: "T1127", technique: "Trusted Developer Utilities" },
      {id: "T1129", technique: "Execution through Module Load" },
      {id: "T1151", technique: "Space after Filename" },
      {id: "T1152", technique: "Launchctl" },
      {id: "T1153", technique: "Source" },
      {id: "T1154", technique: "Trap" },
      {id: "T1155", technique: "AppleScript" },
      {id: "T1168", technique: "Local Job Scheduling" },
      {id: "T1170", technique: "Mshta" },
      {id: "T1173", technique: "Dynamic Data Exchange" },
      {id: "T1175", technique: "Component Object Model and Distributed COM" },
      {id: "T1177", technique: "LSASS Driver" },
      {id: "T1191", technique: "CMSTP" },
      {id: "T1196", technique: "Control Panel Items" },
      {id: "T1203", technique: "Exploitation for Client Execution" },
      {id: "T1204", technique: "User Execution" },
      {id: "T1216", technique: "Signed Script Proxy Execution" },
      {id: "T1218", technique: "Signed Binary Proxy Execution" },
      {id: "T1220", technique: "XSL Script Processing" },
      {id: "T1223", technique: "Compiled HTML File" },
    ]
  },
  {
    "tactic": "Initial Access",
    "rule": [
      {id: "T1078", technique: "Valid Accounts" },
      {id: "T1091", technique: "Replication Through Removable Media" },
      {id: "T1133", technique: "External Remote Services" },
      {id: "T1189", technique: "Drive-by Compromise" },
      {id: "T1190", technique: "Exploit Public-Facing Application" },
      {id: "T1192", technique: "Spearphishing Link" },
      {id: "T1193", technique: "Spearphishing Attachment" },
      {id: "T1194", technique: "Spearphishing via Service" },
      {id: "T1195", technique: "Supply Chain Compromise" },
      {id: "T1199", technique: "Trusted Relationship" },
      {id: "T1200", technique: "Hardware Additions" },
    ]
  },
  {
    "tactic": "Impact",
    "rule": [
      {id: "T1485", technique: "Data Destruction" },
      {id: "T1486", technique: "Data Encrypted for Impact" },
      {id: "T1487", technique: "Disk Structure Wipe" },
      {id: "T1488", technique: "Disk Content Wipe" },
      {id: "T1489", technique: "Service Stop" },
      {id: "T1490", technique: "Inhibit System Recovery" },
      {id: "T1491", technique: "Defacement" },
      {id: "T1492", technique: "Stored Data Manipulation" },
      {id: "T1493", technique: "Transmitted Data Manipulation" },
      {id: "T1494", technique: "Runtime Data Manipulation" },
      {id: "T1495", technique: "Firmware Corruption" },
      {id: "T1496", technique: "Resource Hijacking" },
      {id: "T1498", technique: "Network Denial of Service" },
      {id: "T1499", technique: "Endpoint Denial of Service" },
      {id: "T1529", technique: "System Shutdown/Reboot" },
      {id: "T1531", technique: "Account Access Removal" },
    ]
  }
]

export const arrayGroups = ['syslog', 'authentication_failed', 'sshd', 'sysmon-modular', 'access_control'];
export const arrayLocation = ['EventChannel', '/var/log/auth.log', '/var/log/secure'];
export const arrayRuleDescription = ['sshd: authentication failed.', 'syslog: User missed the password more than one time', 'Multiple Windows Logon Failures', 'sshd: Multiple authentication failures.', 'PAM: User login failed', 'syslog: User missed the password more than one time'];
